##############################################################################
# ui.pm extension file, included from the puic-generated form implementation.
# If you wish to add, delete or rename signals or slots use
# the Perl-enabled Qt Designer which will update this file,
# preserving your code.
#
# 'SLOT:' markers are not meant to be created or edited manually.
# Please use the Slots dialog and/or the Object Browser.
#############################################################################

my $last_space=0;
my $indexFrom=0;
my $indexCP=0;
my $paraCP=0;
my $ctr_para=0;
my $data;

sub init
{
    $data = XML::Simple::XMLin("/home/1024/progz/PKanaEditor/data.xml",KeyAttr=>'romanji');
}


sub destroy
{

}

sub MainEditor_cursorPositionChanged # SLOT: ( int, int )
{
    my ($para,$cindex) = @_;
    $indexCP=$cindex;
    $paraCP=$para;
}


sub MainEditor_returnPressed
{
    $ctr_para=$paraCP;
    my $t = MainEditor->text($ctr_para);
    print "text is \"$t\"\n";
    MainEditor->setSelection($ctr_para,0,$ctr_para,length($t)-1);
    MainEditor->insertParagraph(trUtf8(_RomanjiToKana(trUtf8($t))),$ctr_para);
    MainEditor->setCursorPosition($ctr_para+1,0);
    MainEditor->setSelection($ctr_para+1,0,$ctr_para+1, MainEditor->paragraphLength($ctr_para+1)  );
    MainEditor->removeSelectedText(0);
}


sub _RomanjiToKana # SLOT: ( const QString & )
{
    my $romanji = shift;
    
    foreach my $r (keys( %{ $data->{first}->{item} } ))
    {
	$romanji =~ s/$r/$data->{first}->{item}->{$r}->{kana}/g;
    }
    foreach my $r (keys( %{ $data->{second}->{item} } ))
    {
	$romanji =~ s/$r/$data->{second}->{item}->{$r}->{kana}/g;
    }
    foreach my $r (keys( %{ $data->{third}->{item} } ))
    {
	$romanji =~ s/$r/$data->{third}->{item}->{$r}->{kana}/g;
    }

    return $romanji;
}
